require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MATH_H)) {
    die("Never include <bits/math-vector.h> directly; include <math.h> instead.");
}
require 'bits/libm-simd-decl-stubs.ph';
if(defined (&__x86_64__)  && defined (&__FAST_MATH__)) {
    if(defined (&_OPENMP)  && (defined(&_OPENMP) ? &_OPENMP : undef) >= 201307) {
	eval 'sub __DECL_SIMD_x86_64 () { &_Pragma ("omp declare simd notinbranch");}' unless defined(&__DECL_SIMD_x86_64);
    }
 elsif( &__GNUC_PREREQ (6,0)) {
	eval 'sub __DECL_SIMD_x86_64 () { &__attribute__ (( &__simd__ ("notinbranch")));}' unless defined(&__DECL_SIMD_x86_64);
    }
    if(defined(&__DECL_SIMD_x86_64)) {
	undef(&__DECL_SIMD_cos) if defined(&__DECL_SIMD_cos);
	eval 'sub __DECL_SIMD_cos () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cos);
	undef(&__DECL_SIMD_cosf) if defined(&__DECL_SIMD_cosf);
	eval 'sub __DECL_SIMD_cosf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cosf);
	undef(&__DECL_SIMD_sin) if defined(&__DECL_SIMD_sin);
	eval 'sub __DECL_SIMD_sin () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sin);
	undef(&__DECL_SIMD_sinf) if defined(&__DECL_SIMD_sinf);
	eval 'sub __DECL_SIMD_sinf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sinf);
	undef(&__DECL_SIMD_sincos) if defined(&__DECL_SIMD_sincos);
	eval 'sub __DECL_SIMD_sincos () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sincos);
	undef(&__DECL_SIMD_sincosf) if defined(&__DECL_SIMD_sincosf);
	eval 'sub __DECL_SIMD_sincosf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sincosf);
	undef(&__DECL_SIMD_log) if defined(&__DECL_SIMD_log);
	eval 'sub __DECL_SIMD_log () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log);
	undef(&__DECL_SIMD_logf) if defined(&__DECL_SIMD_logf);
	eval 'sub __DECL_SIMD_logf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_logf);
	undef(&__DECL_SIMD_exp) if defined(&__DECL_SIMD_exp);
	eval 'sub __DECL_SIMD_exp () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_exp);
	undef(&__DECL_SIMD_expf) if defined(&__DECL_SIMD_expf);
	eval 'sub __DECL_SIMD_expf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_expf);
	undef(&__DECL_SIMD_pow) if defined(&__DECL_SIMD_pow);
	eval 'sub __DECL_SIMD_pow () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_pow);
	undef(&__DECL_SIMD_powf) if defined(&__DECL_SIMD_powf);
	eval 'sub __DECL_SIMD_powf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_powf);
	undef(&__DECL_SIMD_acos) if defined(&__DECL_SIMD_acos);
	eval 'sub __DECL_SIMD_acos () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_acos);
	undef(&__DECL_SIMD_acosf) if defined(&__DECL_SIMD_acosf);
	eval 'sub __DECL_SIMD_acosf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_acosf);
	undef(&__DECL_SIMD_atan) if defined(&__DECL_SIMD_atan);
	eval 'sub __DECL_SIMD_atan () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_atan);
	undef(&__DECL_SIMD_atanf) if defined(&__DECL_SIMD_atanf);
	eval 'sub __DECL_SIMD_atanf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_atanf);
	undef(&__DECL_SIMD_asin) if defined(&__DECL_SIMD_asin);
	eval 'sub __DECL_SIMD_asin () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_asin);
	undef(&__DECL_SIMD_asinf) if defined(&__DECL_SIMD_asinf);
	eval 'sub __DECL_SIMD_asinf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_asinf);
	undef(&__DECL_SIMD_hypot) if defined(&__DECL_SIMD_hypot);
	eval 'sub __DECL_SIMD_hypot () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_hypot);
	undef(&__DECL_SIMD_hypotf) if defined(&__DECL_SIMD_hypotf);
	eval 'sub __DECL_SIMD_hypotf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_hypotf);
	undef(&__DECL_SIMD_exp2) if defined(&__DECL_SIMD_exp2);
	eval 'sub __DECL_SIMD_exp2 () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_exp2);
	undef(&__DECL_SIMD_exp2f) if defined(&__DECL_SIMD_exp2f);
	eval 'sub __DECL_SIMD_exp2f () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_exp2f);
	undef(&__DECL_SIMD_exp10) if defined(&__DECL_SIMD_exp10);
	eval 'sub __DECL_SIMD_exp10 () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_exp10);
	undef(&__DECL_SIMD_exp10f) if defined(&__DECL_SIMD_exp10f);
	eval 'sub __DECL_SIMD_exp10f () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_exp10f);
	undef(&__DECL_SIMD_cosh) if defined(&__DECL_SIMD_cosh);
	eval 'sub __DECL_SIMD_cosh () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cosh);
	undef(&__DECL_SIMD_coshf) if defined(&__DECL_SIMD_coshf);
	eval 'sub __DECL_SIMD_coshf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_coshf);
	undef(&__DECL_SIMD_expm1) if defined(&__DECL_SIMD_expm1);
	eval 'sub __DECL_SIMD_expm1 () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_expm1);
	undef(&__DECL_SIMD_expm1f) if defined(&__DECL_SIMD_expm1f);
	eval 'sub __DECL_SIMD_expm1f () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_expm1f);
	undef(&__DECL_SIMD_sinh) if defined(&__DECL_SIMD_sinh);
	eval 'sub __DECL_SIMD_sinh () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sinh);
	undef(&__DECL_SIMD_sinhf) if defined(&__DECL_SIMD_sinhf);
	eval 'sub __DECL_SIMD_sinhf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sinhf);
	undef(&__DECL_SIMD_cbrt) if defined(&__DECL_SIMD_cbrt);
	eval 'sub __DECL_SIMD_cbrt () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cbrt);
	undef(&__DECL_SIMD_cbrtf) if defined(&__DECL_SIMD_cbrtf);
	eval 'sub __DECL_SIMD_cbrtf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cbrtf);
	undef(&__DECL_SIMD_atan2) if defined(&__DECL_SIMD_atan2);
	eval 'sub __DECL_SIMD_atan2 () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_atan2);
	undef(&__DECL_SIMD_atan2f) if defined(&__DECL_SIMD_atan2f);
	eval 'sub __DECL_SIMD_atan2f () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_atan2f);
	undef(&__DECL_SIMD_log10) if defined(&__DECL_SIMD_log10);
	eval 'sub __DECL_SIMD_log10 () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log10);
	undef(&__DECL_SIMD_log10f) if defined(&__DECL_SIMD_log10f);
	eval 'sub __DECL_SIMD_log10f () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log10f);
	undef(&__DECL_SIMD_log2) if defined(&__DECL_SIMD_log2);
	eval 'sub __DECL_SIMD_log2 () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log2);
	undef(&__DECL_SIMD_log2f) if defined(&__DECL_SIMD_log2f);
	eval 'sub __DECL_SIMD_log2f () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log2f);
	undef(&__DECL_SIMD_log1p) if defined(&__DECL_SIMD_log1p);
	eval 'sub __DECL_SIMD_log1p () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log1p);
	undef(&__DECL_SIMD_log1pf) if defined(&__DECL_SIMD_log1pf);
	eval 'sub __DECL_SIMD_log1pf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log1pf);
	undef(&__DECL_SIMD_atanh) if defined(&__DECL_SIMD_atanh);
	eval 'sub __DECL_SIMD_atanh () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_atanh);
	undef(&__DECL_SIMD_atanhf) if defined(&__DECL_SIMD_atanhf);
	eval 'sub __DECL_SIMD_atanhf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_atanhf);
	undef(&__DECL_SIMD_acosh) if defined(&__DECL_SIMD_acosh);
	eval 'sub __DECL_SIMD_acosh () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_acosh);
	undef(&__DECL_SIMD_acoshf) if defined(&__DECL_SIMD_acoshf);
	eval 'sub __DECL_SIMD_acoshf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_acoshf);
	undef(&__DECL_SIMD_erf) if defined(&__DECL_SIMD_erf);
	eval 'sub __DECL_SIMD_erf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_erf);
	undef(&__DECL_SIMD_erff) if defined(&__DECL_SIMD_erff);
	eval 'sub __DECL_SIMD_erff () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_erff);
	undef(&__DECL_SIMD_tanh) if defined(&__DECL_SIMD_tanh);
	eval 'sub __DECL_SIMD_tanh () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_tanh);
	undef(&__DECL_SIMD_tanhf) if defined(&__DECL_SIMD_tanhf);
	eval 'sub __DECL_SIMD_tanhf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_tanhf);
	undef(&__DECL_SIMD_asinh) if defined(&__DECL_SIMD_asinh);
	eval 'sub __DECL_SIMD_asinh () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_asinh);
	undef(&__DECL_SIMD_asinhf) if defined(&__DECL_SIMD_asinhf);
	eval 'sub __DECL_SIMD_asinhf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_asinhf);
	undef(&__DECL_SIMD_erfc) if defined(&__DECL_SIMD_erfc);
	eval 'sub __DECL_SIMD_erfc () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_erfc);
	undef(&__DECL_SIMD_erfcf) if defined(&__DECL_SIMD_erfcf);
	eval 'sub __DECL_SIMD_erfcf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_erfcf);
	undef(&__DECL_SIMD_tan) if defined(&__DECL_SIMD_tan);
	eval 'sub __DECL_SIMD_tan () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_tan);
	undef(&__DECL_SIMD_tanf) if defined(&__DECL_SIMD_tanf);
	eval 'sub __DECL_SIMD_tanf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_tanf);
    }
}
1;
