require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_F2FS_H)) {
    eval 'sub _LINUX_F2FS_H () {1;}' unless defined(&_LINUX_F2FS_H);
    require 'linux/types.ph';
    require 'linux/ioctl.ph';
    eval 'sub F2FS_IOCTL_MAGIC () {0xf5;}' unless defined(&F2FS_IOCTL_MAGIC);
    eval 'sub F2FS_IOC_START_ATOMIC_WRITE () { &_IO( &F2FS_IOCTL_MAGIC, 1);}' unless defined(&F2FS_IOC_START_ATOMIC_WRITE);
    eval 'sub F2FS_IOC_COMMIT_ATOMIC_WRITE () { &_IO( &F2FS_IOCTL_MAGIC, 2);}' unless defined(&F2FS_IOC_COMMIT_ATOMIC_WRITE);
    eval 'sub F2FS_IOC_START_VOLATILE_WRITE () { &_IO( &F2FS_IOCTL_MAGIC, 3);}' unless defined(&F2FS_IOC_START_VOLATILE_WRITE);
    eval 'sub F2FS_IOC_RELEASE_VOLATILE_WRITE () { &_IO( &F2FS_IOCTL_MAGIC, 4);}' unless defined(&F2FS_IOC_RELEASE_VOLATILE_WRITE);
    eval 'sub F2FS_IOC_ABORT_ATOMIC_WRITE () { &_IO( &F2FS_IOCTL_MAGIC, 5);}' unless defined(&F2FS_IOC_ABORT_ATOMIC_WRITE);
    eval 'sub F2FS_IOC_GARBAGE_COLLECT () { &_IOW( &F2FS_IOCTL_MAGIC, 6,  &__u32);}' unless defined(&F2FS_IOC_GARBAGE_COLLECT);
    eval 'sub F2FS_IOC_WRITE_CHECKPOINT () { &_IO( &F2FS_IOCTL_MAGIC, 7);}' unless defined(&F2FS_IOC_WRITE_CHECKPOINT);
    eval 'sub F2FS_IOC_DEFRAGMENT () { &_IOWR( &F2FS_IOCTL_MAGIC, 8, \'struct f2fs_defragment\');}' unless defined(&F2FS_IOC_DEFRAGMENT);
    eval 'sub F2FS_IOC_MOVE_RANGE () { &_IOWR( &F2FS_IOCTL_MAGIC, 9, \'struct f2fs_move_range\');}' unless defined(&F2FS_IOC_MOVE_RANGE);
    eval 'sub F2FS_IOC_FLUSH_DEVICE () { &_IOW( &F2FS_IOCTL_MAGIC, 10, \'struct f2fs_flush_device\');}' unless defined(&F2FS_IOC_FLUSH_DEVICE);
    eval 'sub F2FS_IOC_GARBAGE_COLLECT_RANGE () { &_IOW( &F2FS_IOCTL_MAGIC, 11, \'struct f2fs_gc_range\');}' unless defined(&F2FS_IOC_GARBAGE_COLLECT_RANGE);
    eval 'sub F2FS_IOC_GET_FEATURES () { &_IOR( &F2FS_IOCTL_MAGIC, 12,  &__u32);}' unless defined(&F2FS_IOC_GET_FEATURES);
    eval 'sub F2FS_IOC_SET_PIN_FILE () { &_IOW( &F2FS_IOCTL_MAGIC, 13,  &__u32);}' unless defined(&F2FS_IOC_SET_PIN_FILE);
    eval 'sub F2FS_IOC_GET_PIN_FILE () { &_IOR( &F2FS_IOCTL_MAGIC, 14,  &__u32);}' unless defined(&F2FS_IOC_GET_PIN_FILE);
    eval 'sub F2FS_IOC_PRECACHE_EXTENTS () { &_IO( &F2FS_IOCTL_MAGIC, 15);}' unless defined(&F2FS_IOC_PRECACHE_EXTENTS);
    eval 'sub F2FS_IOC_RESIZE_FS () { &_IOW( &F2FS_IOCTL_MAGIC, 16,  &__u64);}' unless defined(&F2FS_IOC_RESIZE_FS);
    eval 'sub F2FS_IOC_GET_COMPRESS_BLOCKS () { &_IOR( &F2FS_IOCTL_MAGIC, 17,  &__u64);}' unless defined(&F2FS_IOC_GET_COMPRESS_BLOCKS);
    eval 'sub F2FS_IOC_RELEASE_COMPRESS_BLOCKS () { &_IOR( &F2FS_IOCTL_MAGIC, 18,  &__u64);}' unless defined(&F2FS_IOC_RELEASE_COMPRESS_BLOCKS);
    eval 'sub F2FS_IOC_RESERVE_COMPRESS_BLOCKS () { &_IOR( &F2FS_IOCTL_MAGIC, 19,  &__u64);}' unless defined(&F2FS_IOC_RESERVE_COMPRESS_BLOCKS);
    eval 'sub F2FS_IOC_SEC_TRIM_FILE () { &_IOW( &F2FS_IOCTL_MAGIC, 20, \'struct f2fs_sectrim_range\');}' unless defined(&F2FS_IOC_SEC_TRIM_FILE);
    eval 'sub F2FS_IOC_GET_COMPRESS_OPTION () { &_IOR( &F2FS_IOCTL_MAGIC, 21, \'struct f2fs_comp_option\');}' unless defined(&F2FS_IOC_GET_COMPRESS_OPTION);
    eval 'sub F2FS_IOC_SET_COMPRESS_OPTION () { &_IOW( &F2FS_IOCTL_MAGIC, 22, \'struct f2fs_comp_option\');}' unless defined(&F2FS_IOC_SET_COMPRESS_OPTION);
    eval 'sub F2FS_IOC_DECOMPRESS_FILE () { &_IO( &F2FS_IOCTL_MAGIC, 23);}' unless defined(&F2FS_IOC_DECOMPRESS_FILE);
    eval 'sub F2FS_IOC_COMPRESS_FILE () { &_IO( &F2FS_IOCTL_MAGIC, 24);}' unless defined(&F2FS_IOC_COMPRESS_FILE);
    eval 'sub F2FS_IOC_START_ATOMIC_REPLACE () { &_IO( &F2FS_IOCTL_MAGIC, 25);}' unless defined(&F2FS_IOC_START_ATOMIC_REPLACE);
    eval 'sub F2FS_IOC_GET_DEV_ALIAS_FILE () { &_IOR( &F2FS_IOCTL_MAGIC, 26,  &__u32);}' unless defined(&F2FS_IOC_GET_DEV_ALIAS_FILE);
    eval 'sub F2FS_IOC_SHUTDOWN () { &_IOR(ord(\'X\'), 125,  &__u32);}' unless defined(&F2FS_IOC_SHUTDOWN);
    eval 'sub F2FS_GOING_DOWN_FULLSYNC () {0x;}' unless defined(&F2FS_GOING_DOWN_FULLSYNC);
    eval 'sub F2FS_GOING_DOWN_METASYNC () {0x1;}' unless defined(&F2FS_GOING_DOWN_METASYNC);
    eval 'sub F2FS_GOING_DOWN_NOSYNC () {0x2;}' unless defined(&F2FS_GOING_DOWN_NOSYNC);
    eval 'sub F2FS_GOING_DOWN_METAFLUSH () {0x3;}' unless defined(&F2FS_GOING_DOWN_METAFLUSH);
    eval 'sub F2FS_GOING_DOWN_NEED_FSCK () {0x4;}' unless defined(&F2FS_GOING_DOWN_NEED_FSCK);
    eval 'sub F2FS_TRIM_FILE_DISCARD () {0x1;}' unless defined(&F2FS_TRIM_FILE_DISCARD);
    eval 'sub F2FS_TRIM_FILE_ZEROOUT () {0x2;}' unless defined(&F2FS_TRIM_FILE_ZEROOUT);
    eval 'sub F2FS_TRIM_FILE_MASK () {0x3;}' unless defined(&F2FS_TRIM_FILE_MASK);
}
1;
