require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_STAT_H)) {
    eval 'sub _LINUX_STAT_H () {1;}' unless defined(&_LINUX_STAT_H);
    require 'linux/types.ph';
    if(defined(&__KERNEL__) || !defined(&__GLIBC__) || ((defined(&__GLIBC__) ? &__GLIBC__ : undef) < 2)) {
	eval 'sub S_IFMT () {00170000;}' unless defined(&S_IFMT);
	eval 'sub S_IFSOCK () {0140000;}' unless defined(&S_IFSOCK);
	eval 'sub S_IFLNK () {0120000;}' unless defined(&S_IFLNK);
	eval 'sub S_IFREG () {0100000;}' unless defined(&S_IFREG);
	eval 'sub S_IFBLK () {0060000;}' unless defined(&S_IFBLK);
	eval 'sub S_IFDIR () {0040000;}' unless defined(&S_IFDIR);
	eval 'sub S_IFCHR () {0020000;}' unless defined(&S_IFCHR);
	eval 'sub S_IFIFO () {0010000;}' unless defined(&S_IFIFO);
	eval 'sub S_ISUID () {0004000;}' unless defined(&S_ISUID);
	eval 'sub S_ISGID () {0002000;}' unless defined(&S_ISGID);
	eval 'sub S_ISVTX () {0001000;}' unless defined(&S_ISVTX);
	eval 'sub S_ISLNK {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFLNK));
	}' unless defined(&S_ISLNK);
	eval 'sub S_ISREG {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFREG));
	}' unless defined(&S_ISREG);
	eval 'sub S_ISDIR {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFDIR));
	}' unless defined(&S_ISDIR);
	eval 'sub S_ISCHR {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFCHR));
	}' unless defined(&S_ISCHR);
	eval 'sub S_ISBLK {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFBLK));
	}' unless defined(&S_ISBLK);
	eval 'sub S_ISFIFO {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFIFO));
	}' unless defined(&S_ISFIFO);
	eval 'sub S_ISSOCK {
	    my($m) = @_;
    	    eval q(((($m) &  &S_IFMT) ==  &S_IFSOCK));
	}' unless defined(&S_ISSOCK);
	eval 'sub S_IRWXU () {00700;}' unless defined(&S_IRWXU);
	eval 'sub S_IRUSR () {00400;}' unless defined(&S_IRUSR);
	eval 'sub S_IWUSR () {00200;}' unless defined(&S_IWUSR);
	eval 'sub S_IXUSR () {00100;}' unless defined(&S_IXUSR);
	eval 'sub S_IRWXG () {00070;}' unless defined(&S_IRWXG);
	eval 'sub S_IRGRP () {00040;}' unless defined(&S_IRGRP);
	eval 'sub S_IWGRP () {00020;}' unless defined(&S_IWGRP);
	eval 'sub S_IXGRP () {00010;}' unless defined(&S_IXGRP);
	eval 'sub S_IRWXO () {00007;}' unless defined(&S_IRWXO);
	eval 'sub S_IROTH () {00004;}' unless defined(&S_IROTH);
	eval 'sub S_IWOTH () {00002;}' unless defined(&S_IWOTH);
	eval 'sub S_IXOTH () {00001;}' unless defined(&S_IXOTH);
    }
    eval 'sub STATX_TYPE () {0x1;}' unless defined(&STATX_TYPE);
    eval 'sub STATX_MODE () {0x2;}' unless defined(&STATX_MODE);
    eval 'sub STATX_NLINK () {0x4;}' unless defined(&STATX_NLINK);
    eval 'sub STATX_UID () {0x8;}' unless defined(&STATX_UID);
    eval 'sub STATX_GID () {0x10;}' unless defined(&STATX_GID);
    eval 'sub STATX_ATIME () {0x20;}' unless defined(&STATX_ATIME);
    eval 'sub STATX_MTIME () {0x40;}' unless defined(&STATX_MTIME);
    eval 'sub STATX_CTIME () {0x80;}' unless defined(&STATX_CTIME);
    eval 'sub STATX_INO () {0x100;}' unless defined(&STATX_INO);
    eval 'sub STATX_SIZE () {0x200;}' unless defined(&STATX_SIZE);
    eval 'sub STATX_BLOCKS () {0x400;}' unless defined(&STATX_BLOCKS);
    eval 'sub STATX_BASIC_STATS () {0x7ff;}' unless defined(&STATX_BASIC_STATS);
    eval 'sub STATX_BTIME () {0x800;}' unless defined(&STATX_BTIME);
    eval 'sub STATX_MNT_ID () {0x1000;}' unless defined(&STATX_MNT_ID);
    eval 'sub STATX_DIOALIGN () {0x2000;}' unless defined(&STATX_DIOALIGN);
    eval 'sub STATX_MNT_ID_UNIQUE () {0x4000;}' unless defined(&STATX_MNT_ID_UNIQUE);
    eval 'sub STATX_SUBVOL () {0x8000;}' unless defined(&STATX_SUBVOL);
    eval 'sub STATX_WRITE_ATOMIC () {0x10000;}' unless defined(&STATX_WRITE_ATOMIC);
    eval 'sub STATX__RESERVED () {0x80000000;}' unless defined(&STATX__RESERVED);
    eval 'sub STATX_ALL () {0xfff;}' unless defined(&STATX_ALL);
    eval 'sub STATX_ATTR_COMPRESSED () {0x4;}' unless defined(&STATX_ATTR_COMPRESSED);
    eval 'sub STATX_ATTR_IMMUTABLE () {0x10;}' unless defined(&STATX_ATTR_IMMUTABLE);
    eval 'sub STATX_ATTR_APPEND () {0x20;}' unless defined(&STATX_ATTR_APPEND);
    eval 'sub STATX_ATTR_NODUMP () {0x40;}' unless defined(&STATX_ATTR_NODUMP);
    eval 'sub STATX_ATTR_ENCRYPTED () {0x800;}' unless defined(&STATX_ATTR_ENCRYPTED);
    eval 'sub STATX_ATTR_AUTOMOUNT () {0x1000;}' unless defined(&STATX_ATTR_AUTOMOUNT);
    eval 'sub STATX_ATTR_MOUNT_ROOT () {0x2000;}' unless defined(&STATX_ATTR_MOUNT_ROOT);
    eval 'sub STATX_ATTR_VERITY () {0x100000;}' unless defined(&STATX_ATTR_VERITY);
    eval 'sub STATX_ATTR_DAX () {0x200000;}' unless defined(&STATX_ATTR_DAX);
    eval 'sub STATX_ATTR_WRITE_ATOMIC () {0x400000;}' unless defined(&STATX_ATTR_WRITE_ATOMIC);
}
1;
