require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_LINUX_VIRTIO_NET_H)) {
    eval 'sub _LINUX_VIRTIO_NET_H () {1;}' unless defined(&_LINUX_VIRTIO_NET_H);
    require 'linux/types.ph';
    require 'linux/virtio_ids.ph';
    require 'linux/virtio_config.ph';
    require 'linux/virtio_types.ph';
    require 'linux/if_ether.ph';
    eval 'sub VIRTIO_NET_F_CSUM () {0;}' unless defined(&VIRTIO_NET_F_CSUM);
    eval 'sub VIRTIO_NET_F_GUEST_CSUM () {1;}' unless defined(&VIRTIO_NET_F_GUEST_CSUM);
    eval 'sub VIRTIO_NET_F_CTRL_GUEST_OFFLOADS () {2;}' unless defined(&VIRTIO_NET_F_CTRL_GUEST_OFFLOADS);
    eval 'sub VIRTIO_NET_F_MTU () {3;}' unless defined(&VIRTIO_NET_F_MTU);
    eval 'sub VIRTIO_NET_F_MAC () {5;}' unless defined(&VIRTIO_NET_F_MAC);
    eval 'sub VIRTIO_NET_F_GUEST_TSO4 () {7;}' unless defined(&VIRTIO_NET_F_GUEST_TSO4);
    eval 'sub VIRTIO_NET_F_GUEST_TSO6 () {8;}' unless defined(&VIRTIO_NET_F_GUEST_TSO6);
    eval 'sub VIRTIO_NET_F_GUEST_ECN () {9;}' unless defined(&VIRTIO_NET_F_GUEST_ECN);
    eval 'sub VIRTIO_NET_F_GUEST_UFO () {10;}' unless defined(&VIRTIO_NET_F_GUEST_UFO);
    eval 'sub VIRTIO_NET_F_HOST_TSO4 () {11;}' unless defined(&VIRTIO_NET_F_HOST_TSO4);
    eval 'sub VIRTIO_NET_F_HOST_TSO6 () {12;}' unless defined(&VIRTIO_NET_F_HOST_TSO6);
    eval 'sub VIRTIO_NET_F_HOST_ECN () {13;}' unless defined(&VIRTIO_NET_F_HOST_ECN);
    eval 'sub VIRTIO_NET_F_HOST_UFO () {14;}' unless defined(&VIRTIO_NET_F_HOST_UFO);
    eval 'sub VIRTIO_NET_F_MRG_RXBUF () {15;}' unless defined(&VIRTIO_NET_F_MRG_RXBUF);
    eval 'sub VIRTIO_NET_F_STATUS () {16;}' unless defined(&VIRTIO_NET_F_STATUS);
    eval 'sub VIRTIO_NET_F_CTRL_VQ () {17;}' unless defined(&VIRTIO_NET_F_CTRL_VQ);
    eval 'sub VIRTIO_NET_F_CTRL_RX () {18;}' unless defined(&VIRTIO_NET_F_CTRL_RX);
    eval 'sub VIRTIO_NET_F_CTRL_VLAN () {19;}' unless defined(&VIRTIO_NET_F_CTRL_VLAN);
    eval 'sub VIRTIO_NET_F_CTRL_RX_EXTRA () {20;}' unless defined(&VIRTIO_NET_F_CTRL_RX_EXTRA);
    eval 'sub VIRTIO_NET_F_GUEST_ANNOUNCE () {21;}' unless defined(&VIRTIO_NET_F_GUEST_ANNOUNCE);
    eval 'sub VIRTIO_NET_F_MQ () {22;}' unless defined(&VIRTIO_NET_F_MQ);
    eval 'sub VIRTIO_NET_F_CTRL_MAC_ADDR () {23;}' unless defined(&VIRTIO_NET_F_CTRL_MAC_ADDR);
    eval 'sub VIRTIO_NET_F_DEVICE_STATS () {50;}' unless defined(&VIRTIO_NET_F_DEVICE_STATS);
    eval 'sub VIRTIO_NET_F_VQ_NOTF_COAL () {52;}' unless defined(&VIRTIO_NET_F_VQ_NOTF_COAL);
    eval 'sub VIRTIO_NET_F_NOTF_COAL () {53;}' unless defined(&VIRTIO_NET_F_NOTF_COAL);
    eval 'sub VIRTIO_NET_F_GUEST_USO4 () {54;}' unless defined(&VIRTIO_NET_F_GUEST_USO4);
    eval 'sub VIRTIO_NET_F_GUEST_USO6 () {55;}' unless defined(&VIRTIO_NET_F_GUEST_USO6);
    eval 'sub VIRTIO_NET_F_HOST_USO () {56;}' unless defined(&VIRTIO_NET_F_HOST_USO);
    eval 'sub VIRTIO_NET_F_HASH_REPORT () {57;}' unless defined(&VIRTIO_NET_F_HASH_REPORT);
    eval 'sub VIRTIO_NET_F_GUEST_HDRLEN () {59;}' unless defined(&VIRTIO_NET_F_GUEST_HDRLEN);
    eval 'sub VIRTIO_NET_F_RSS () {60;}' unless defined(&VIRTIO_NET_F_RSS);
    eval 'sub VIRTIO_NET_F_RSC_EXT () {61;}' unless defined(&VIRTIO_NET_F_RSC_EXT);
    eval 'sub VIRTIO_NET_F_STANDBY () {62;}' unless defined(&VIRTIO_NET_F_STANDBY);
    eval 'sub VIRTIO_NET_F_SPEED_DUPLEX () {63;}' unless defined(&VIRTIO_NET_F_SPEED_DUPLEX);
    unless(defined(&VIRTIO_NET_NO_LEGACY)) {
	eval 'sub VIRTIO_NET_F_GSO () {6;}' unless defined(&VIRTIO_NET_F_GSO);
    }
    eval 'sub VIRTIO_NET_S_LINK_UP () {1;}' unless defined(&VIRTIO_NET_S_LINK_UP);
    eval 'sub VIRTIO_NET_S_ANNOUNCE () {2;}' unless defined(&VIRTIO_NET_S_ANNOUNCE);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_IPv4 () {(1<< 0);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_IPv4);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_TCPv4 () {(1<< 1);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_TCPv4);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_UDPv4 () {(1<< 2);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_UDPv4);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_IPv6 () {(1<< 3);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_IPv6);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_TCPv6 () {(1<< 4);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_TCPv6);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_UDPv6 () {(1<< 5);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_UDPv6);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_IP_EX () {(1<< 6);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_IP_EX);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_TCP_EX () {(1<< 7);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_TCP_EX);
    eval 'sub VIRTIO_NET_RSS_HASH_TYPE_UDP_EX () {(1<< 8);}' unless defined(&VIRTIO_NET_RSS_HASH_TYPE_UDP_EX);
    eval 'sub VIRTIO_NET_HDR_F_NEEDS_CSUM () {1;}' unless defined(&VIRTIO_NET_HDR_F_NEEDS_CSUM);
    eval 'sub VIRTIO_NET_HDR_F_DATA_VALID () {2;}' unless defined(&VIRTIO_NET_HDR_F_DATA_VALID);
    eval 'sub VIRTIO_NET_HDR_F_RSC_INFO () {4;}' unless defined(&VIRTIO_NET_HDR_F_RSC_INFO);
    eval 'sub VIRTIO_NET_HDR_GSO_NONE () {0;}' unless defined(&VIRTIO_NET_HDR_GSO_NONE);
    eval 'sub VIRTIO_NET_HDR_GSO_TCPV4 () {1;}' unless defined(&VIRTIO_NET_HDR_GSO_TCPV4);
    eval 'sub VIRTIO_NET_HDR_GSO_UDP () {3;}' unless defined(&VIRTIO_NET_HDR_GSO_UDP);
    eval 'sub VIRTIO_NET_HDR_GSO_TCPV6 () {4;}' unless defined(&VIRTIO_NET_HDR_GSO_TCPV6);
    eval 'sub VIRTIO_NET_HDR_GSO_UDP_L4 () {5;}' unless defined(&VIRTIO_NET_HDR_GSO_UDP_L4);
    eval 'sub VIRTIO_NET_HDR_GSO_ECN () {0x80;}' unless defined(&VIRTIO_NET_HDR_GSO_ECN);
    eval 'sub VIRTIO_NET_HASH_REPORT_NONE () {0;}' unless defined(&VIRTIO_NET_HASH_REPORT_NONE);
    eval 'sub VIRTIO_NET_HASH_REPORT_IPv4 () {1;}' unless defined(&VIRTIO_NET_HASH_REPORT_IPv4);
    eval 'sub VIRTIO_NET_HASH_REPORT_TCPv4 () {2;}' unless defined(&VIRTIO_NET_HASH_REPORT_TCPv4);
    eval 'sub VIRTIO_NET_HASH_REPORT_UDPv4 () {3;}' unless defined(&VIRTIO_NET_HASH_REPORT_UDPv4);
    eval 'sub VIRTIO_NET_HASH_REPORT_IPv6 () {4;}' unless defined(&VIRTIO_NET_HASH_REPORT_IPv6);
    eval 'sub VIRTIO_NET_HASH_REPORT_TCPv6 () {5;}' unless defined(&VIRTIO_NET_HASH_REPORT_TCPv6);
    eval 'sub VIRTIO_NET_HASH_REPORT_UDPv6 () {6;}' unless defined(&VIRTIO_NET_HASH_REPORT_UDPv6);
    eval 'sub VIRTIO_NET_HASH_REPORT_IPv6_EX () {7;}' unless defined(&VIRTIO_NET_HASH_REPORT_IPv6_EX);
    eval 'sub VIRTIO_NET_HASH_REPORT_TCPv6_EX () {8;}' unless defined(&VIRTIO_NET_HASH_REPORT_TCPv6_EX);
    eval 'sub VIRTIO_NET_HASH_REPORT_UDPv6_EX () {9;}' unless defined(&VIRTIO_NET_HASH_REPORT_UDPv6_EX);
    unless(defined(&VIRTIO_NET_NO_LEGACY)) {
    }
    eval 'sub VIRTIO_NET_OK () {0;}' unless defined(&VIRTIO_NET_OK);
    eval 'sub VIRTIO_NET_ERR () {1;}' unless defined(&VIRTIO_NET_ERR);
    eval 'sub VIRTIO_NET_CTRL_RX () {0;}' unless defined(&VIRTIO_NET_CTRL_RX);
    eval 'sub VIRTIO_NET_CTRL_RX_PROMISC () {0;}' unless defined(&VIRTIO_NET_CTRL_RX_PROMISC);
    eval 'sub VIRTIO_NET_CTRL_RX_ALLMULTI () {1;}' unless defined(&VIRTIO_NET_CTRL_RX_ALLMULTI);
    eval 'sub VIRTIO_NET_CTRL_RX_ALLUNI () {2;}' unless defined(&VIRTIO_NET_CTRL_RX_ALLUNI);
    eval 'sub VIRTIO_NET_CTRL_RX_NOMULTI () {3;}' unless defined(&VIRTIO_NET_CTRL_RX_NOMULTI);
    eval 'sub VIRTIO_NET_CTRL_RX_NOUNI () {4;}' unless defined(&VIRTIO_NET_CTRL_RX_NOUNI);
    eval 'sub VIRTIO_NET_CTRL_RX_NOBCAST () {5;}' unless defined(&VIRTIO_NET_CTRL_RX_NOBCAST);
    eval 'sub VIRTIO_NET_CTRL_MAC () {1;}' unless defined(&VIRTIO_NET_CTRL_MAC);
    eval 'sub VIRTIO_NET_CTRL_MAC_TABLE_SET () {0;}' unless defined(&VIRTIO_NET_CTRL_MAC_TABLE_SET);
    eval 'sub VIRTIO_NET_CTRL_MAC_ADDR_SET () {1;}' unless defined(&VIRTIO_NET_CTRL_MAC_ADDR_SET);
    eval 'sub VIRTIO_NET_CTRL_VLAN () {2;}' unless defined(&VIRTIO_NET_CTRL_VLAN);
    eval 'sub VIRTIO_NET_CTRL_VLAN_ADD () {0;}' unless defined(&VIRTIO_NET_CTRL_VLAN_ADD);
    eval 'sub VIRTIO_NET_CTRL_VLAN_DEL () {1;}' unless defined(&VIRTIO_NET_CTRL_VLAN_DEL);
    eval 'sub VIRTIO_NET_CTRL_ANNOUNCE () {3;}' unless defined(&VIRTIO_NET_CTRL_ANNOUNCE);
    eval 'sub VIRTIO_NET_CTRL_ANNOUNCE_ACK () {0;}' unless defined(&VIRTIO_NET_CTRL_ANNOUNCE_ACK);
    eval 'sub VIRTIO_NET_CTRL_MQ () {4;}' unless defined(&VIRTIO_NET_CTRL_MQ);
    eval 'sub VIRTIO_NET_CTRL_MQ_VQ_PAIRS_SET () {0;}' unless defined(&VIRTIO_NET_CTRL_MQ_VQ_PAIRS_SET);
    eval 'sub VIRTIO_NET_CTRL_MQ_VQ_PAIRS_MIN () {1;}' unless defined(&VIRTIO_NET_CTRL_MQ_VQ_PAIRS_MIN);
    eval 'sub VIRTIO_NET_CTRL_MQ_VQ_PAIRS_MAX () {0x8000;}' unless defined(&VIRTIO_NET_CTRL_MQ_VQ_PAIRS_MAX);
    eval 'sub VIRTIO_NET_CTRL_MQ_RSS_CONFIG () {1;}' unless defined(&VIRTIO_NET_CTRL_MQ_RSS_CONFIG);
    eval 'sub VIRTIO_NET_CTRL_MQ_HASH_CONFIG () {2;}' unless defined(&VIRTIO_NET_CTRL_MQ_HASH_CONFIG);
    eval 'sub VIRTIO_NET_CTRL_GUEST_OFFLOADS () {5;}' unless defined(&VIRTIO_NET_CTRL_GUEST_OFFLOADS);
    eval 'sub VIRTIO_NET_CTRL_GUEST_OFFLOADS_SET () {0;}' unless defined(&VIRTIO_NET_CTRL_GUEST_OFFLOADS_SET);
    eval 'sub VIRTIO_NET_CTRL_NOTF_COAL () {6;}' unless defined(&VIRTIO_NET_CTRL_NOTF_COAL);
    eval 'sub VIRTIO_NET_CTRL_NOTF_COAL_TX_SET () {0;}' unless defined(&VIRTIO_NET_CTRL_NOTF_COAL_TX_SET);
    eval 'sub VIRTIO_NET_CTRL_NOTF_COAL_RX_SET () {1;}' unless defined(&VIRTIO_NET_CTRL_NOTF_COAL_RX_SET);
    eval 'sub VIRTIO_NET_CTRL_NOTF_COAL_VQ_SET () {2;}' unless defined(&VIRTIO_NET_CTRL_NOTF_COAL_VQ_SET);
    eval 'sub VIRTIO_NET_CTRL_NOTF_COAL_VQ_GET () {3;}' unless defined(&VIRTIO_NET_CTRL_NOTF_COAL_VQ_GET);
    eval 'sub VIRTIO_NET_CTRL_STATS () {8;}' unless defined(&VIRTIO_NET_CTRL_STATS);
    eval 'sub VIRTIO_NET_CTRL_STATS_QUERY () {0;}' unless defined(&VIRTIO_NET_CTRL_STATS_QUERY);
    eval 'sub VIRTIO_NET_CTRL_STATS_GET () {1;}' unless defined(&VIRTIO_NET_CTRL_STATS_GET);
    eval 'sub VIRTIO_NET_STATS_TYPE_CVQ () {(1 << 32);}' unless defined(&VIRTIO_NET_STATS_TYPE_CVQ);
    eval 'sub VIRTIO_NET_STATS_TYPE_RX_BASIC () {(1 << 0);}' unless defined(&VIRTIO_NET_STATS_TYPE_RX_BASIC);
    eval 'sub VIRTIO_NET_STATS_TYPE_RX_CSUM () {(1 << 1);}' unless defined(&VIRTIO_NET_STATS_TYPE_RX_CSUM);
    eval 'sub VIRTIO_NET_STATS_TYPE_RX_GSO () {(1 << 2);}' unless defined(&VIRTIO_NET_STATS_TYPE_RX_GSO);
    eval 'sub VIRTIO_NET_STATS_TYPE_RX_SPEED () {(1 << 3);}' unless defined(&VIRTIO_NET_STATS_TYPE_RX_SPEED);
    eval 'sub VIRTIO_NET_STATS_TYPE_TX_BASIC () {(1 << 16);}' unless defined(&VIRTIO_NET_STATS_TYPE_TX_BASIC);
    eval 'sub VIRTIO_NET_STATS_TYPE_TX_CSUM () {(1 << 17);}' unless defined(&VIRTIO_NET_STATS_TYPE_TX_CSUM);
    eval 'sub VIRTIO_NET_STATS_TYPE_TX_GSO () {(1 << 18);}' unless defined(&VIRTIO_NET_STATS_TYPE_TX_GSO);
    eval 'sub VIRTIO_NET_STATS_TYPE_TX_SPEED () {(1 << 19);}' unless defined(&VIRTIO_NET_STATS_TYPE_TX_SPEED);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_CVQ () {32;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_CVQ);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_RX_BASIC () {0;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_RX_BASIC);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_RX_CSUM () {1;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_RX_CSUM);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_RX_GSO () {2;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_RX_GSO);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_RX_SPEED () {3;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_RX_SPEED);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_TX_BASIC () {16;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_TX_BASIC);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_TX_CSUM () {17;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_TX_CSUM);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_TX_GSO () {18;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_TX_GSO);
    eval 'sub VIRTIO_NET_STATS_TYPE_REPLY_TX_SPEED () {19;}' unless defined(&VIRTIO_NET_STATS_TYPE_REPLY_TX_SPEED);
}
1;
