require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_PTHREAD_H)) {
    eval 'sub _PTHREAD_H () {1;}' unless defined(&_PTHREAD_H);
    require 'features.ph';
    require 'sched.ph';
    require 'time.ph';
    require 'bits/endian.ph';
    require 'bits/pthreadtypes.ph';
    require 'bits/setjmp.ph';
    require 'bits/wordsize.ph';
    require 'bits/types/struct_timespec.ph';
    require 'bits/types/__sigset_t.ph';
    require 'bits/types/struct___jmp_buf_tag.ph';
    if(defined(&__USE_MISC)) {
	require 'bits/pthread_stack_min-dynamic.ph';
    }
    eval("sub PTHREAD_CREATE_JOINABLE () { 0; }") unless defined(&PTHREAD_CREATE_JOINABLE);
    eval("sub PTHREAD_CREATE_DETACHED () { 1; }") unless defined(&PTHREAD_CREATE_DETACHED);
    eval("sub PTHREAD_MUTEX_TIMED_NP () { 0; }") unless defined(&PTHREAD_MUTEX_TIMED_NP);
    eval("sub PTHREAD_MUTEX_RECURSIVE_NP () { 1; }") unless defined(&PTHREAD_MUTEX_RECURSIVE_NP);
    eval("sub PTHREAD_MUTEX_ERRORCHECK_NP () { 2; }") unless defined(&PTHREAD_MUTEX_ERRORCHECK_NP);
    eval("sub PTHREAD_MUTEX_ADAPTIVE_NP () { 3; }") unless defined(&PTHREAD_MUTEX_ADAPTIVE_NP);
    if(defined(&__USE_XOPEN2K)) {
	eval("sub PTHREAD_MUTEX_STALLED () { 0; }") unless defined(&PTHREAD_MUTEX_STALLED);
	eval("sub PTHREAD_MUTEX_STALLED_NP () { PTHREAD_MUTEX_STALLED; }") unless defined(&PTHREAD_MUTEX_STALLED_NP);
	eval("sub PTHREAD_MUTEX_ROBUST () { 1; }") unless defined(&PTHREAD_MUTEX_ROBUST);
	eval("sub PTHREAD_MUTEX_ROBUST_NP () { PTHREAD_MUTEX_ROBUST; }") unless defined(&PTHREAD_MUTEX_ROBUST_NP);
    }
    if(defined (&__USE_POSIX199506) || defined (&__USE_UNIX98)) {
	eval("sub PTHREAD_PRIO_NONE () { 0; }") unless defined(&PTHREAD_PRIO_NONE);
	eval("sub PTHREAD_PRIO_INHERIT () { 1; }") unless defined(&PTHREAD_PRIO_INHERIT);
	eval("sub PTHREAD_PRIO_PROTECT () { 2; }") unless defined(&PTHREAD_PRIO_PROTECT);
    }
    eval 'sub PTHREAD_MUTEX_INITIALIZER () {{ {  &__PTHREAD_MUTEX_INITIALIZER ( &PTHREAD_MUTEX_TIMED_NP) } };}' unless defined(&PTHREAD_MUTEX_INITIALIZER);
    if(defined(&__USE_GNU)) {
	eval 'sub PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP () {{ {  &__PTHREAD_MUTEX_INITIALIZER ( &PTHREAD_MUTEX_RECURSIVE_NP) } };}' unless defined(&PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP);
	eval 'sub PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP () {{ {  &__PTHREAD_MUTEX_INITIALIZER ( &PTHREAD_MUTEX_ERRORCHECK_NP) } };}' unless defined(&PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP);
	eval 'sub PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP () {{ {  &__PTHREAD_MUTEX_INITIALIZER ( &PTHREAD_MUTEX_ADAPTIVE_NP) } };}' unless defined(&PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP);
    }
    if(defined (&__USE_UNIX98) || defined (&__USE_XOPEN2K)) {
	eval("sub PTHREAD_RWLOCK_PREFER_READER_NP () { 0; }") unless defined(&PTHREAD_RWLOCK_PREFER_READER_NP);
	eval("sub PTHREAD_RWLOCK_PREFER_WRITER_NP () { 1; }") unless defined(&PTHREAD_RWLOCK_PREFER_WRITER_NP);
	eval("sub PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP () { 2; }") unless defined(&PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP);
	eval("sub PTHREAD_RWLOCK_DEFAULT_NP () { PTHREAD_RWLOCK_PREFER_READER_NP; }") unless defined(&PTHREAD_RWLOCK_DEFAULT_NP);
	eval 'sub PTHREAD_RWLOCK_INITIALIZER () {{ {  &__PTHREAD_RWLOCK_INITIALIZER ( &PTHREAD_RWLOCK_DEFAULT_NP) } };}' unless defined(&PTHREAD_RWLOCK_INITIALIZER);
	if(defined(&__USE_GNU)) {
	    eval 'sub PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP () {{ {  &__PTHREAD_RWLOCK_INITIALIZER ( &PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP) } };}' unless defined(&PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP);
	}
    }
    eval("sub PTHREAD_INHERIT_SCHED () { 0; }") unless defined(&PTHREAD_INHERIT_SCHED);
    eval("sub PTHREAD_EXPLICIT_SCHED () { 1; }") unless defined(&PTHREAD_EXPLICIT_SCHED);
    eval("sub PTHREAD_SCOPE_SYSTEM () { 0; }") unless defined(&PTHREAD_SCOPE_SYSTEM);
    eval("sub PTHREAD_SCOPE_PROCESS () { 1; }") unless defined(&PTHREAD_SCOPE_PROCESS);
    eval("sub PTHREAD_PROCESS_PRIVATE () { 0; }") unless defined(&PTHREAD_PROCESS_PRIVATE);
    eval("sub PTHREAD_PROCESS_SHARED () { 1; }") unless defined(&PTHREAD_PROCESS_SHARED);
    eval 'sub PTHREAD_COND_INITIALIZER () {{ { {0}, {0}, {0, 0}, {0, 0}, 0, 0, {0, 0} } };}' unless defined(&PTHREAD_COND_INITIALIZER);
    eval("sub PTHREAD_CANCEL_ENABLE () { 0; }") unless defined(&PTHREAD_CANCEL_ENABLE);
    eval("sub PTHREAD_CANCEL_DISABLE () { 1; }") unless defined(&PTHREAD_CANCEL_DISABLE);
    eval("sub PTHREAD_CANCEL_DEFERRED () { 0; }") unless defined(&PTHREAD_CANCEL_DEFERRED);
    eval("sub PTHREAD_CANCEL_ASYNCHRONOUS () { 1; }") unless defined(&PTHREAD_CANCEL_ASYNCHRONOUS);
    eval 'sub PTHREAD_CANCELED () {(( &void *) -1);}' unless defined(&PTHREAD_CANCELED);
    eval 'sub PTHREAD_ONCE_INIT () {0;}' unless defined(&PTHREAD_ONCE_INIT);
    if(defined(&__USE_XOPEN2K)) {
	eval 'sub PTHREAD_BARRIER_SERIAL_THREAD () {-1;}' unless defined(&PTHREAD_BARRIER_SERIAL_THREAD);
    }
    if(defined(&__USE_GNU)) {
	unless(defined(&__USE_TIME64_REDIRECTS)) {
	} else {
	    if(defined(&__REDIRECT)) {
	    } else {
		eval 'sub pthread_timedjoin_np () { &__pthread_timedjoin_np64;}' unless defined(&pthread_timedjoin_np);
		eval 'sub pthread_clockjoin_np () { &__pthread_clockjoin_np64;}' unless defined(&pthread_clockjoin_np);
	    }
	}
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    if(defined(&__USE_GNU)) {
	eval 'sub PTHREAD_ATTR_NO_SIGMASK_NP () {(-1);}' unless defined(&PTHREAD_ATTR_NO_SIGMASK_NP);
    }
    if(defined(&__USE_GNU)) {
    }
    if(defined(&__USE_UNIX98)) {
    }
    if(defined(&__USE_GNU)) {
	if(defined(&__REDIRECT_NTH)) {
	} else {
	    eval 'sub pthread_yield () { &sched_yield;}' unless defined(&pthread_yield);
	}
    }
    unless(defined(&__cleanup_fct_attribute)) {
	eval 'sub __cleanup_fct_attribute () {1;}' unless defined(&__cleanup_fct_attribute);
    }
    if(defined (&__GNUC__)  && defined (&__EXCEPTIONS)) {
	if(defined(&__cplusplus)) {
	    eval 'sub pthread_cleanup_push {
	        my($routine, $arg) = @_;
    		eval q( &do {  &__pthread_cleanup_class  &__clframe ($routine, $arg));
	    }' unless defined(&pthread_cleanup_push);
	    eval 'sub pthread_cleanup_pop {
	        my($execute) = @_;
    		eval q( ($__clframe->{__setdoit}) ($execute); }  &while (0));
	    }' unless defined(&pthread_cleanup_pop);
	    if(defined(&__USE_GNU)) {
		eval 'sub pthread_cleanup_push_defer_np {
		    my($routine, $arg) = @_;
    		    eval q( &do {  &__pthread_cleanup_class  &__clframe ($routine, $arg);  ($__clframe->{__defer}) ());
		}' unless defined(&pthread_cleanup_push_defer_np);
		eval 'sub pthread_cleanup_pop_restore_np {
		    my($execute) = @_;
    		    eval q( ($__clframe->{__restore}) ();  ($__clframe->{__setdoit}) ($execute); }  &while (0));
		}' unless defined(&pthread_cleanup_pop_restore_np);
	    }
	} else {
	    eval 'sub pthread_cleanup_push {
	        my($routine, $arg) = @_;
    		eval q( &do { \'struct __pthread_cleanup_frame\'  &__clframe  &__attribute__ (( &__cleanup__ ( &__pthread_cleanup_routine))) = { . &__cancel_routine = ($routine), . &__cancel_arg = ($arg), . &__do_it = 1};);
	    }' unless defined(&pthread_cleanup_push);
	    eval 'sub pthread_cleanup_pop {
	        my($execute) = @_;
    		eval q( ($__clframe->{__do_it}) = ($execute); }  &while (0));
	    }' unless defined(&pthread_cleanup_pop);
	    if(defined(&__USE_GNU)) {
		eval 'sub pthread_cleanup_push_defer_np {
		    my($routine, $arg) = @_;
    		    eval q( &do { \'struct __pthread_cleanup_frame\'  &__clframe  &__attribute__ (( &__cleanup__ ( &__pthread_cleanup_routine))) = { . &__cancel_routine = ($routine), . &__cancel_arg = ($arg), . &__do_it = 1}; ( &void)  &pthread_setcanceltype ( &PTHREAD_CANCEL_DEFERRED, & ($__clframe->{__cancel_type})));
		}' unless defined(&pthread_cleanup_push_defer_np);
		eval 'sub pthread_cleanup_pop_restore_np {
		    my($execute) = @_;
    		    eval q(( &void)  &pthread_setcanceltype ( ($__clframe->{__cancel_type}),  &NULL);  ($__clframe->{__do_it}) = ($execute); }  &while (0));
		}' unless defined(&pthread_cleanup_pop_restore_np);
	    }
	}
    } else {
	eval 'sub pthread_cleanup_push {
	    my($routine, $arg) = @_;
    	    eval q( &do {  &__pthread_unwind_buf_t  &__cancel_buf;  &void (* &__cancel_routine) ( &void *) = ($routine);  &void * &__cancel_arg = ($arg); \'int\'  &__not_first_call =  &__sigsetjmp_cancel ( ($__cancel_buf->{__cancel_jmp_buf}), 0);  &if ( &__glibc_unlikely ( &__not_first_call)) {  &__cancel_routine ( &__cancel_arg);  &__pthread_unwind_next (& &__cancel_buf); }  &__pthread_register_cancel (& &__cancel_buf);  &do {);
	}' unless defined(&pthread_cleanup_push);
	eval 'sub pthread_cleanup_pop {
	    my($execute) = @_;
    	    eval q( &do { }  &while (0); }  &while (0);  &__pthread_unregister_cancel (& &__cancel_buf);  &if ($execute)  &__cancel_routine ( &__cancel_arg); }  &while (0));
	}' unless defined(&pthread_cleanup_pop);
	if(defined(&__USE_GNU)) {
	    eval 'sub pthread_cleanup_push_defer_np {
	        my($routine, $arg) = @_;
    		eval q( &do {  &__pthread_unwind_buf_t  &__cancel_buf;  &void (* &__cancel_routine) ( &void *) = ($routine);  &void * &__cancel_arg = ($arg); \'int\'  &__not_first_call =  &__sigsetjmp_cancel ( ($__cancel_buf->{__cancel_jmp_buf}), 0);  &if ( &__glibc_unlikely ( &__not_first_call)) {  &__cancel_routine ( &__cancel_arg);  &__pthread_unwind_next (& &__cancel_buf); }  &__pthread_register_cancel_defer (& &__cancel_buf);  &do {);
	    }' unless defined(&pthread_cleanup_push_defer_np);
	    eval 'sub pthread_cleanup_pop_restore_np {
	        my($execute) = @_;
    		eval q( &do { }  &while (0); }  &while (0);  &__pthread_unregister_cancel_restore (& &__cancel_buf);  &if ($execute)  &__cancel_routine ( &__cancel_arg); }  &while (0));
	    }' unless defined(&pthread_cleanup_pop_restore_np);
	}
	unless(defined(&SHARED)) {
	}
    }
    if( &__GNUC_PREREQ (11, 0)) {
    } else {
	eval 'sub __sigsetjmp_cancel {
	    my($env, $savemask) = @_;
    	    eval q( &__sigsetjmp ( ( &void *) ($env), ($savemask)));
	}' unless defined(&__sigsetjmp_cancel);
    }
    if(defined(&__USE_XOPEN2K)) {
	unless(defined(&__USE_TIME64_REDIRECTS)) {
	} else {
	    if(defined(&__REDIRECT_NTHNL)) {
	    } else {
		eval 'sub pthread_mutex_timedlock () { &__pthread_mutex_timedlock64;}' unless defined(&pthread_mutex_timedlock);
	    }
	}
    }
    if(defined(&__USE_GNU)) {
	unless(defined(&__USE_TIME64_REDIRECTS)) {
	} else {
	    if(defined(&__REDIRECT_NTHNL)) {
	    } else {
		eval 'sub pthread_mutex_clocklock () { &__pthread_mutex_clocklock64;}' unless defined(&pthread_mutex_clocklock);
	    }
	}
    }
    if(defined(&__USE_XOPEN2K8)) {
	if(defined(&__USE_GNU)) {
	    if(defined(&__REDIRECT_NTH)) {
	    } else {
		eval 'sub pthread_mutex_consistent_np () { &pthread_mutex_consistent;}' unless defined(&pthread_mutex_consistent_np);
	    }
	}
    }
    if(defined (&__USE_UNIX98) || defined (&__USE_XOPEN2K8)) {
    }
    if(defined(&__USE_XOPEN2K)) {
	if(defined(&__USE_GNU)) {
	    if(defined(&__REDIRECT_NTH)) {
	    } else {
		eval 'sub pthread_mutexattr_getrobust_np () { &pthread_mutexattr_getrobust;}' unless defined(&pthread_mutexattr_getrobust_np);
	    }
	}
	if(defined(&__USE_GNU)) {
	    if(defined(&__REDIRECT_NTH)) {
	    } else {
		eval 'sub pthread_mutexattr_setrobust_np () { &pthread_mutexattr_setrobust;}' unless defined(&pthread_mutexattr_setrobust_np);
	    }
	}
    }
    if(defined (&__USE_UNIX98) || defined (&__USE_XOPEN2K)) {
	if(defined(&__USE_XOPEN2K)) {
	    unless(defined(&__USE_TIME64_REDIRECTS)) {
	    } else {
		if(defined(&__REDIRECT_NTHNL)) {
		} else {
		    eval 'sub pthread_rwlock_timedrdlock () { &__pthread_rwlock_timedrdlock64;}' unless defined(&pthread_rwlock_timedrdlock);
		}
	    }
	}
	if(defined(&__USE_GNU)) {
	    unless(defined(&__USE_TIME64_REDIRECTS)) {
	    } else {
		if(defined(&__REDIRECT_NTHNL)) {
		} else {
		    eval 'sub pthread_rwlock_clockrdlock () { &__pthread_rwlock_clockrdlock64;}' unless defined(&pthread_rwlock_clockrdlock);
		}
	    }
	}
	if(defined(&__USE_XOPEN2K)) {
	    unless(defined(&__USE_TIME64_REDIRECTS)) {
	    } else {
		if(defined(&__REDIRECT_NTHNL)) {
		} else {
		    eval 'sub pthread_rwlock_timedwrlock () { &__pthread_rwlock_timedwrlock64;}' unless defined(&pthread_rwlock_timedwrlock);
		}
	    }
	}
	if(defined(&__USE_GNU)) {
	    unless(defined(&__USE_TIME64_REDIRECTS)) {
	    } else {
		if(defined(&__REDIRECT_NTHNL)) {
		} else {
		    eval 'sub pthread_rwlock_clockwrlock () { &__pthread_rwlock_clockwrlock64;}' unless defined(&pthread_rwlock_clockwrlock);
		}
	    }
	}
    }
    unless(defined(&__USE_TIME64_REDIRECTS)) {
    } else {
	if(defined(&__REDIRECT)) {
	} else {
	    eval 'sub pthread_cond_timedwait () { &__pthread_cond_timedwait64;}' unless defined(&pthread_cond_timedwait);
	}
    }
    if(defined(&__USE_GNU)) {
	unless(defined(&__USE_TIME64_REDIRECTS)) {
	} else {
	    if(defined(&__REDIRECT)) {
	    } else {
		eval 'sub pthread_cond_clockwait () { &__pthread_cond_clockwait64;}' unless defined(&pthread_cond_clockwait);
	    }
	}
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    if(defined(&__USE_EXTERN_INLINES)) {
    }
}
1;
